import { i as styleInject, u as useDivaCoreContext } from './index-d507f225.js';
import { useState, useEffect, useCallback } from 'react';
import { observer } from 'mobx-react-lite';
import Button from '@mui/material/Button';
import Dialog from '@mui/material/Dialog';
import DialogActions from '@mui/material/DialogActions';
import DialogContent from '@mui/material/DialogContent';
import DialogContentText from '@mui/material/DialogContentText';
import DialogTitle from '@mui/material/DialogTitle';
import { useTranslation } from 'react-i18next';
import _slicedToArray from '@babel/runtime/helpers/slicedToArray';
import { jsxs, jsx, Fragment } from 'react/jsx-runtime';
import { IconButton } from '@mui/material';
import CloseIcon from '@mui/icons-material/Close';
import { toJS } from 'mobx';
import '@babel/runtime/helpers/classCallCheck';
import '@babel/runtime/helpers/createClass';
import '@babel/runtime/helpers/defineProperty';
import '@elastic/apm-rum';
import '@crystaldesign/diva-utils';
import '@babel/runtime/helpers/possibleConstructorReturn';
import '@babel/runtime/helpers/getPrototypeOf';
import '@babel/runtime/helpers/inherits';
import '@babel/runtime/helpers/wrapNativeSuper';
import 'react-dom';
import '@babel/runtime/helpers/asyncToGenerator';
import '@babel/runtime/helpers/objectWithoutProperties';
import '@babel/runtime/regenerator';
import '@babel/runtime/helpers/toConsumableArray';
import 'mobile-detect';
import 'platform';
import 'i18next';
import 'i18next-http-backend';
import '@mui/material/styles';
import '@mui/material/locale';
import '@elastic/apm-rum-react';
import '@mui/material/Typography';
import 'classnames';
import '@mui/icons-material';
import '@crystaldesign/basket-model';
import 'lodash/debounce';
import 'axios';
import '@crystaldesign/product-handler';
import 'react-swipeable';
import '@crystaldesign/content-box';
import '@crystaldesign/diva-core';
import 'react-qr-code';
import '@mui/material/IconButton';
import '@mui/icons-material/HelpOutline';
import '@storybook/addon-actions';
import '@mui/styles';

var overlay = "overlay-hhcfc";
var css_248z$1 = ".overlay-hhcfc {\n  height: 100%;\n  width: 100%;\n  display: flex;\n  background-color: rgba(255, 255, 255, 0.6);\n  z-index: 1001;\n  justify-content: center;\n  align-items: center;\n  position: absolute;\n}\n";
styleInject(css_248z$1);

var wrapper = "wrapper-myuaV";
var fullProgressbar = "fullProgressbar-XbHCx";
var growingProgressbarWrapper = "growingProgressbarWrapper-ovxln";
var growingProgressbar = "growingProgressbar-XdK17";
var css_248z = ".wrapper-myuaV {\n  display: flex;\n  width: 100%;\n}\n\n.fullProgressbar-XbHCx {\n  height: 10px;\n  position: relative;\n  border-radius: 5px;\n  width: 100%;\n}\n\n@keyframes slide-fJJD6 {\n  from {\n    background-position-x: 0;\n  }\n  to {\n    background-position-x: 113px;\n  }\n}\n\n.growingProgressbarWrapper-ovxln {\n  position: absolute;\n  top: 0;\n  left: 0;\n  height: 100%;\n  transition: width 0.4s ease-out;\n  overflow: hidden;\n  border-radius: 5px;\n}\n.growingProgressbar-XdK17 {\n  border-radius: 5px;\n  height: 100%;\n  background-color: var(--diva-theme-palette-primary-main);\n  background-image: repeating-linear-gradient(\n    45deg,\n    transparent,\n    transparent 10px,\n    var(--diva-theme-palette-secondary-dark) 10px,\n    var(--diva-theme-palette-secondary-dark) 20px\n  );\n  animation: slide-fJJD6 4s linear infinite;\n  will-change: background-position;\n}\n";
styleInject(css_248z);

var Progress = function Progress(_ref) {
  var children = _ref.children,
    progress = _ref.progress;
  var _useState = useState(),
    _useState2 = _slicedToArray(_useState, 2),
    oldProgress = _useState2[0],
    setOldProgress = _useState2[1];
  useEffect(function () {
    setOldProgress(progress);
  }, [progress]);
  return /*#__PURE__*/jsxs("div", {
    className: wrapper,
    children: [!!children && children, /*#__PURE__*/jsx("div", {
      className: fullProgressbar,
      children: /*#__PURE__*/jsx("div", {
        className: growingProgressbarWrapper,
        style: {
          width: (oldProgress !== null && oldProgress !== void 0 ? oldProgress : 0) * 100 + '%'
        },
        children: /*#__PURE__*/jsx("div", {
          className: growingProgressbar
        })
      })
    })]
  });
};
var Progress$1 = observer(Progress);

function Modal() {
  var _pureModal$actions, _pureModal$actions2;
  var _useDivaCoreContext = useDivaCoreContext(),
    contentStore = _useDivaCoreContext.contentStore;
  var _useTranslation = useTranslation(),
    t = _useTranslation.t;
  var onAccept = function onAccept(data) {
    var _modal$callback;
    var modal = contentStore.modal;
    contentStore.closeModal();
    modal === null || modal === void 0 || (_modal$callback = modal.callback) === null || _modal$callback === void 0 || _modal$callback.call(modal, modal.content ? data : true);
  };
  var onReject = function onReject() {
    var _modal$callback2;
    var modal = contentStore.modal;
    contentStore.closeModal();
    modal === null || modal === void 0 || (_modal$callback2 = modal.callback) === null || _modal$callback2 === void 0 || _modal$callback2.call(modal, false);
  };
  var onSelect = function onSelect(id, closeable) {
    var _modal$callback3;
    var modal = contentStore.modal;
    if (closeable != false) {
      contentStore.closeModal();
    }
    modal === null || modal === void 0 || (_modal$callback3 = modal.callback) === null || _modal$callback3 === void 0 || _modal$callback3.call(modal, id);
  };
  function tryDecodeURIComponent(val) {
    try {
      return decodeURIComponent(val);
    } catch (_unused) {
      return val;
    }
  }
  useEffect(function () {
    document.addEventListener('keydown', keyDownFunction, false);
    return function () {
      document.removeEventListener('keydown', keyDownFunction, false);
    };
  }, []);
  var keyDownFunction = useCallback(function (e) {
    if (!contentStore.modal) return;
    if (e.key === 'Enter' && !contentStore.modal.doNotAcceptOnEnter) {
      var form = document.getElementById('diva-modal-form');
      if (!form) return;
      onAccept(new FormData(form));
      e.preventDefault();
    } else if (e.key === 'ESC' || e.key == 'Escape') {
      onReject();
      e.preventDefault();
    }
  }, []);
  if (!contentStore.modal) return /*#__PURE__*/jsx(Fragment, {});
  var pureModal = toJS(contentStore.modal);
  var text = typeof pureModal.text == 'string' ? t(pureModal.text) : pureModal.text;
  var children = /*#__PURE__*/jsxs(Fragment, {
    children: [/*#__PURE__*/jsx(DialogContent, {
      style: pureModal.maxWidth ? {
        maxWidth: pureModal.maxWidth
      } : undefined,
      children: pureModal.iFrame ? /*#__PURE__*/jsx(IFrame, {
        link: pureModal.iFrame
      }) : typeof text == 'string' && pureModal.content == undefined ? /*#__PURE__*/jsx(DialogContentText, {
        component: "div",
        dangerouslySetInnerHTML: {
          __html: tryDecodeURIComponent(text)
        }
      }) : /*#__PURE__*/jsxs(DialogContentText, {
        component: "div",
        children: [text, pureModal.content && pureModal.content]
      })
    }), (pureModal.reject || pureModal.accept) && /*#__PURE__*/jsxs(DialogActions, {
      children: [pureModal.reject && /*#__PURE__*/jsx(Button, {
        color: "primary",
        onClick: onReject,
        children: typeof pureModal.reject == 'string' ? t(pureModal.reject) : t('modal.reject')
      }), pureModal.accept && /*#__PURE__*/jsx(Button, {
        color: "primary",
        type: "submit",
        id: "diva-dialog-submitbtn",
        children: typeof pureModal.accept == 'string' ? t(pureModal.accept) : t('modal.accept')
      })]
    }), !!(pureModal.image || pureModal.progress !== undefined || (_pureModal$actions = pureModal.actions) !== null && _pureModal$actions !== void 0 && _pureModal$actions.length) && /*#__PURE__*/jsxs("div", {
      style: {
        margin: 10
      },
      children: [pureModal.image && /*#__PURE__*/jsx("img", {
        src: pureModal.image,
        style: {
          maxWidth: 480
        }
      }), pureModal.progress !== undefined && /*#__PURE__*/jsx(Progress$1, {
        progress: pureModal.progress
      }), (_pureModal$actions2 = pureModal.actions) === null || _pureModal$actions2 === void 0 ? void 0 : _pureModal$actions2.map(function (a) {
        var _a$variant;
        return /*#__PURE__*/jsx(Button, {
          fullWidth: true,
          style: {
            marginBottom: 10
          },
          variant: (_a$variant = a.variant) !== null && _a$variant !== void 0 ? _a$variant : 'contained',
          color: "primary",
          onClick: function onClick() {
            return onSelect(a.id, a.closeable);
          },
          children: t(a.text)
        });
      })]
    })]
  });
  var isFullscreen = pureModal.fullscreen === true || pureModal.fullscreen == 'mobile' && contentStore.containerDimensions.isMobile;
  return /*#__PURE__*/jsx("div", {
    className: overlay,
    id: "diva-dialog",
    children: /*#__PURE__*/jsxs(Dialog, {
      open: true,
      disablePortal: true,
      hideBackdrop: true,
      disableEnforceFocus: true,
      style: {
        position: 'absolute',
        zIndex: 0
      },
      maxWidth: "lg",
      fullScreen: isFullscreen,
      PaperProps: {
        style: {
          width: pureModal.width,
          height: pureModal.height
        }
      },
      children: [/*#__PURE__*/jsx(DialogTitle, {
        children: typeof pureModal.title == 'string' ? t(pureModal.title) : pureModal.title
      }), pureModal.rejectByIcon && /*#__PURE__*/jsx(IconButton, {
        onClick: onReject,
        style: {
          position: 'absolute',
          right: 8,
          top: 8,
          zIndex: 1000001
        },
        size: "large",
        children: /*#__PURE__*/jsx(CloseIcon, {})
      }), pureModal.dontRenderForm && children, !pureModal.dontRenderForm && /*#__PURE__*/jsx("form", {
        id: "diva-modal-form",
        autoComplete: "off",
        onSubmit: function onSubmit(e) {
          e.preventDefault();
          onAccept(new FormData(e.target));
        },
        children: children
      })]
    })
  });
}
var Modal$1 = observer(Modal);
function IFrame(_ref) {
  var link = _ref.link;
  return /*#__PURE__*/jsx("iframe", {
    style: {
      border: 0,
      width: '100%',
      height: '99%'
    },
    src: link
  });
}

function ModalsWrapper () {
  return /*#__PURE__*/jsx(Modal$1, {});
}

export { ModalsWrapper as default };
