import { u as useDivaCoreContext, A as AuthButton, s as socialButton, g as google, m as microsoft, t as titlecontainer, e as error, a as getLogger, b as separator, I as Input, l as link, c as success, d as auth, f as loginBox, h as logoContainer } from './index-d507f225.js';
import { useState, useRef, useEffect, useMemo } from 'react';
import _asyncToGenerator from '@babel/runtime/helpers/asyncToGenerator';
import _slicedToArray from '@babel/runtime/helpers/slicedToArray';
import _regeneratorRuntime from '@babel/runtime/regenerator';
import { observer } from 'mobx-react-lite';
import { DivaError } from '@crystaldesign/diva-utils';
import { flowResult, toJS } from 'mobx';
import { useTranslation } from 'react-i18next';
import classnames from 'classnames';
import { jsxs, Fragment, jsx } from 'react/jsx-runtime';
import CircularProgress from '@mui/material/CircularProgress';
import Alert from '@mui/material/Alert';
import { useTranslation as useTranslation$1 } from '@crystaldesign/diva-core';
import { ContentBoxComponent } from '@crystaldesign/content-box';
import { Alert as Alert$1, CircularProgress as CircularProgress$1 } from '@mui/material';
import Checkbox from '@mui/material/Checkbox';
import Snowfall from 'react-snowfall';
import '@babel/runtime/helpers/classCallCheck';
import '@babel/runtime/helpers/createClass';
import '@babel/runtime/helpers/defineProperty';
import '@elastic/apm-rum';
import '@babel/runtime/helpers/possibleConstructorReturn';
import '@babel/runtime/helpers/getPrototypeOf';
import '@babel/runtime/helpers/inherits';
import '@babel/runtime/helpers/wrapNativeSuper';
import 'react-dom';
import '@babel/runtime/helpers/objectWithoutProperties';
import '@babel/runtime/helpers/toConsumableArray';
import 'mobile-detect';
import 'platform';
import 'i18next';
import 'i18next-http-backend';
import '@mui/material/styles';
import '@mui/material/locale';
import '@elastic/apm-rum-react';
import '@mui/material/Typography';
import '@mui/material/Button';
import '@mui/icons-material';
import '@crystaldesign/basket-model';
import 'lodash/debounce';
import 'axios';
import '@crystaldesign/product-handler';
import 'react-swipeable';
import 'react-qr-code';
import '@mui/icons-material/Close';
import '@mui/material/IconButton';
import '@mui/icons-material/HelpOutline';
import '@storybook/addon-actions';
import '@mui/styles';

function OpenId () {
  var _authorizationStore$s, _loginMethods$generic, _loginMethods$generic2;
  var _useDivaCoreContext = useDivaCoreContext(),
    configurationStore = _useDivaCoreContext.configurationStore,
    authorizationStore = _useDivaCoreContext.authorizationStore;
  var _useTranslation = useTranslation(),
    t = _useTranslation.t;
  var loginMethods = (_authorizationStore$s = authorizationStore.state) === null || _authorizationStore$s === void 0 ? void 0 : _authorizationStore$s.loginMethods;
  return /*#__PURE__*/jsxs(Fragment, {
    children: [(loginMethods === null || loginMethods === void 0 ? void 0 : loginMethods.google) && /*#__PURE__*/jsxs(AuthButton, {
      className: classnames(socialButton, google),
      onClick: function onClick() {
        var _authorizationStore$s2;
        return authorizationStore.openOAuthLogin('google', authorizationStore.state.organizationId, (_authorizationStore$s2 = authorizationStore.state) === null || _authorizationStore$s2 === void 0 ? void 0 : _authorizationStore$s2.invitationId);
      },
      children: [/*#__PURE__*/jsx("div", {}), t('auth.login.google')]
    }), (loginMethods === null || loginMethods === void 0 ? void 0 : loginMethods.microsoft) && /*#__PURE__*/jsxs(AuthButton, {
      className: classnames(socialButton, microsoft),
      onClick: function onClick() {
        var _authorizationStore$s3;
        return authorizationStore.openOAuthLogin('microsoft', authorizationStore.state.organizationId, (_authorizationStore$s3 = authorizationStore.state) === null || _authorizationStore$s3 === void 0 ? void 0 : _authorizationStore$s3.invitationId);
      },
      children: [/*#__PURE__*/jsx("div", {}), t('auth.login.microsoft')]
    }), (loginMethods === null || loginMethods === void 0 ? void 0 : loginMethods.generic) && /*#__PURE__*/jsxs(AuthButton, {
      className: socialButton,
      style: {
        backgroundColor: (_loginMethods$generic = loginMethods.generic.backgroundColor) !== null && _loginMethods$generic !== void 0 ? _loginMethods$generic : configurationStore.theme.palette.secondary.main,
        color: (_loginMethods$generic2 = loginMethods.generic.color) !== null && _loginMethods$generic2 !== void 0 ? _loginMethods$generic2 : configurationStore.theme.palette.secondary.contrastText
      },
      onClick: function onClick() {
        var _authorizationStore$s4;
        return authorizationStore.openOAuthLogin('genericOpenId', authorizationStore.state.organizationId, (_authorizationStore$s4 = authorizationStore.state) === null || _authorizationStore$s4 === void 0 ? void 0 : _authorizationStore$s4.invitationId);
      },
      children: [/*#__PURE__*/jsx("div", {
        style: loginMethods.generic.logo ? {
          backgroundImage: "url(".concat(loginMethods.generic.logo, ")"),
          filter: 'brightness(0) invert(1)'
        } : {}
      }), t('auth.login.generic')]
    })]
  });
}

function Header (_ref) {
  var title = _ref.title,
    text = _ref.text,
    errorText = _ref.errorText;
  var _useTranslation = useTranslation$1(),
    t = _useTranslation.t;
  return /*#__PURE__*/jsxs(Fragment, {
    children: [/*#__PURE__*/jsx("div", {
      className: titlecontainer,
      children: /*#__PURE__*/jsx("h2", {
        children: title
      })
    }), /*#__PURE__*/jsx("p", {
      children: text
    }), errorText && /*#__PURE__*/jsx(Alert, {
      severity: "error",
      className: error,
      children: t(errorText)
    })]
  });
}

var LOG$3 = getLogger('Framework', 'Login');
function Login() {
  var _email, _authorizationStore$s, _authorizationStore$s2, _authorizationStore$s3;
  var _useDivaCoreContext = useDivaCoreContext(),
    authorizationStore = _useDivaCoreContext.authorizationStore,
    authorizationHandler = _useDivaCoreContext.authorizationHandler;
  var _useState = useState('enter'),
    _useState2 = _slicedToArray(_useState, 2),
    step = _useState2[0],
    setStep = _useState2[1];
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    loading = _useState4[0],
    setLoading = _useState4[1];
  var _useState5 = useState((_email = (_authorizationStore$s = authorizationStore.state) === null || _authorizationStore$s === void 0 ? void 0 : _authorizationStore$s.email) !== null && _email !== void 0 ? _email : ''),
    _useState6 = _slicedToArray(_useState5, 2),
    email = _useState6[0],
    setEmail = _useState6[1];
  var _useState7 = useState(''),
    _useState8 = _slicedToArray(_useState7, 2),
    password = _useState8[0],
    setPassword = _useState8[1];
  var _useState9 = useState(''),
    _useState10 = _slicedToArray(_useState9, 2),
    otp = _useState10[0],
    setOtp = _useState10[1];
  var _useState11 = useState(false),
    _useState12 = _slicedToArray(_useState11, 2),
    useOtp = _useState12[0],
    setUseOtp = _useState12[1];
  var _useState13 = useState(authorizationStore.state.invitationId),
    _useState14 = _slicedToArray(_useState13, 2),
    invitationFound = _useState14[0],
    setInvitationFound = _useState14[1];
  var _useState15 = useState(((_authorizationStore$s2 = authorizationStore.state) === null || _authorizationStore$s2 === void 0 ? void 0 : _authorizationStore$s2.type) == 'LOGIN' ? authorizationStore.state.error : undefined),
    _useState16 = _slicedToArray(_useState15, 2),
    errorText = _useState16[0],
    setError = _useState16[1];
  var _useTranslation = useTranslation(),
    t = _useTranslation.t;
  var onContinue = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var checkInvitation, response;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            setLoading(true);
            if (errorText) {
              setError(undefined);
            }
            _context.prev = 2;
            if (invitationFound) {
              _context.next = 8;
              break;
            }
            _context.next = 6;
            return authorizationHandler.getInvitationValue('id', email);
          case 6:
            checkInvitation = _context.sent;
            if (checkInvitation) {
              if (checkInvitation.isNewUser) {
                authorizationStore.close();
                authorizationStore.showRegister(undefined, email, checkInvitation.useotp ? true : false);
              }
              setInvitationFound(true);
              if (checkInvitation.useotp) setUseOtp(true);
            }
          case 8:
            _context.next = 10;
            return authorizationHandler.fetchLoginProvider({
              email: email
            });
          case 10:
            response = _context.sent;
            if (response.provider == 'standard') {
              setStep('login');
            } else {
              authorizationStore.openOAuthLogin(response.provider, authorizationStore.state.organizationId, authorizationStore.state.invitationId);
            }
            _context.next = 18;
            break;
          case 14:
            _context.prev = 14;
            _context.t0 = _context["catch"](2);
            LOG$3.error(new DivaError('Error while fetching login provider', {
              cause: _context.t0
            }));
            setError('auth.error.password');
          case 18:
            _context.prev = 18;
            setLoading(false);
            return _context.finish(18);
          case 21:
          case "end":
            return _context.stop();
        }
      }, _callee, null, [[2, 14, 18, 21]]);
    }));
    return function onContinue() {
      return _ref.apply(this, arguments);
    };
  }();
  var onLogin = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            setLoading(true);
            if (errorText) {
              setError(undefined);
            }
            _context2.prev = 2;
            _context2.next = 5;
            return flowResult(authorizationStore.login(email, password, false, authorizationStore.state.organizationId, authorizationStore.state.invitationId, otp));
          case 5:
            setEmail('');
            setPassword('');
            setError(undefined);
            _context2.next = 14;
            break;
          case 10:
            _context2.prev = 10;
            _context2.t0 = _context2["catch"](2);
            LOG$3.error(new DivaError('Error while logging in', {
              cause: _context2.t0
            }));
            setError(invitationFound ? 'auth.error.passwordotp' : 'auth.error.password');
          case 14:
            _context2.prev = 14;
            setLoading(false);
            return _context2.finish(14);
          case 17:
          case "end":
            return _context2.stop();
        }
      }, _callee2, null, [[2, 10, 14, 17]]);
    }));
    return function onLogin() {
      return _ref2.apply(this, arguments);
    };
  }();
  var reset = function reset() {
    setStep('enter');
    setEmail('');
    setPassword('');
    setError(undefined);
  };
  var resetPassword = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
      return _regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) switch (_context3.prev = _context3.next) {
          case 0:
            authorizationStore.showRequestNewPassword(email);
          case 1:
          case "end":
            return _context3.stop();
        }
      }, _callee3);
    }));
    return function resetPassword() {
      return _ref3.apply(this, arguments);
    };
  }();
  var loginDisabled = step == 'enter' && email.length == 0 || step != 'enter' && password.length == 0;
  if (useOtp && !loginDisabled) loginDisabled = otp.length == 0;
  var loginMethods = (_authorizationStore$s3 = authorizationStore.state) === null || _authorizationStore$s3 === void 0 ? void 0 : _authorizationStore$s3.loginMethods;
  return /*#__PURE__*/jsxs(Fragment, {
    children: [/*#__PURE__*/jsx(Header, {
      title: t('auth.title.login'),
      text: t('auth.text.login', ''),
      errorText: errorText !== null && errorText !== void 0 ? errorText : ''
    }), /*#__PURE__*/jsx(OpenId, {}), ((loginMethods === null || loginMethods === void 0 ? void 0 : loginMethods.generic) || (loginMethods === null || loginMethods === void 0 ? void 0 : loginMethods.google) || (loginMethods === null || loginMethods === void 0 ? void 0 : loginMethods.microsoft)) && loginMethods.standard && /*#__PURE__*/jsx("div", {
      className: separator,
      children: "or"
    }), (loginMethods === null || loginMethods === void 0 ? void 0 : loginMethods.standard) && /*#__PURE__*/jsxs(Fragment, {
      children: [step == 'enter' && /*#__PURE__*/jsxs("form", {
        children: [/*#__PURE__*/jsx(Input, {
          id: "username",
          value: email,
          autoComplete: "username",
          autoFocus: true,
          type: "email",
          placeholder: t('auth.input.email'),
          onChange: function onChange(e) {
            return setEmail(e.target.value);
          },
          onKeyPress: function onKeyPress(e) {
            return e.key == 'Enter' ? onContinue() : false;
          }
        }), /*#__PURE__*/jsx(Input, {
          value: password,
          id: "password",
          type: "password",
          autoComplete: "current-password",
          hidden: true,
          autoFocus: true,
          placeholder: t('auth.input.password'),
          onChange: function onChange(e) {
            return setPassword(e.target.value);
          },
          onKeyPress: function onKeyPress(e) {
            return e.key == 'Enter' ? onLogin() : false;
          }
        })]
      }), step == 'login' && /*#__PURE__*/jsxs("form", {
        children: [useOtp && /*#__PURE__*/jsx(Input, {
          value: otp,
          type: "text",
          autoFocus: true,
          placeholder: t('auth.input.otp'),
          onChange: function onChange(e) {
            return setOtp(e.target.value);
          }
        }), /*#__PURE__*/jsx(Input, {
          value: email,
          type: "email",
          readOnly: true,
          placeholder: t('auth.input.email'),
          resetInput: reset
        }), /*#__PURE__*/jsx(Input, {
          value: password,
          type: "password",
          id: "password",
          autoFocus: true,
          placeholder: t('auth.input.password'),
          onChange: function onChange(e) {
            return setPassword(e.target.value);
          },
          onKeyPress: function onKeyPress(e) {
            return e.key == 'Enter' ? onLogin() : false;
          }
        })]
      }), /*#__PURE__*/jsxs(AuthButton, {
        id: "submit",
        disabled: loginDisabled || loading,
        onClick: step == 'enter' ? onContinue : onLogin,
        children: [loading ? /*#__PURE__*/jsx(CircularProgress, {
          size: 24,
          color: "inherit"
        }) : undefined, loading ? undefined : step == 'enter' ? t('auth.button.continue') : t('auth.button.login')]
      }), step == 'login' && /*#__PURE__*/jsx("div", {
        style: {
          textAlign: 'center'
        },
        children: /*#__PURE__*/jsx("div", {
          className: link,
          onClick: resetPassword,
          children: t('auth.button.forgotpassword')
        })
      }), ' ']
    })]
  });
}
var Login$1 = observer(Login);

var LOG$2 = getLogger('Framework', 'RequestNewPassword');
function RequestNewPassword (_ref) {
  var initEmail = _ref.initEmail;
  var _useDivaCoreContext = useDivaCoreContext(),
    authorizationStore = _useDivaCoreContext.authorizationStore,
    apiHandler = _useDivaCoreContext.apiHandler,
    loadingAndErrorStore = _useDivaCoreContext.loadingAndErrorStore;
  var _useState = useState(initEmail),
    _useState2 = _slicedToArray(_useState, 2),
    email = _useState2[0],
    setEmail = _useState2[1];
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    requested = _useState4[0],
    setRequested = _useState4[1];
  var _useState5 = useState(),
    _useState6 = _slicedToArray(_useState5, 2),
    errorText = _useState6[0],
    setError = _useState6[1];
  var _useState7 = useState(),
    _useState8 = _slicedToArray(_useState7, 2),
    sending = _useState8[0],
    setSending = _useState8[1];
  var _useTranslation = useTranslation(),
    t = _useTranslation.t;
  var resetPassword = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            setSending(true);
            loadingAndErrorStore.toggleLoading('SendPassword');
            _context.next = 5;
            return apiHandler.sendPasswordRecoveryMail({
              email: email
            });
          case 5:
            setSending(false);
            loadingAndErrorStore.toggleLoading('SendPassword');
            setRequested(true);
            setError(undefined);
            _context.next = 17;
            break;
          case 11:
            _context.prev = 11;
            _context.t0 = _context["catch"](0);
            LOG$2.error(new DivaError('Error while sending password recovery mail', {
              cause: _context.t0
            }));
            setError('auth.error.resetpassword');
            setSending(false);
            loadingAndErrorStore.toggleLoading('SendPassword');
          case 17:
          case "end":
            return _context.stop();
        }
      }, _callee, null, [[0, 11]]);
    }));
    return function resetPassword() {
      return _ref2.apply(this, arguments);
    };
  }();
  var toLogin = function toLogin() {
    authorizationStore.close();
    authorizationStore.showLogin();
  };
  return /*#__PURE__*/jsxs(Fragment, {
    children: [/*#__PURE__*/jsx(Header, {
      title: t('auth.title.resetpassword'),
      text: t('auth.info.resetdescription', ''),
      errorText: errorText !== null && errorText !== void 0 ? errorText : ''
    }), requested && /*#__PURE__*/jsxs("div", {
      className: success,
      children: [/*#__PURE__*/jsx("span", {}), /*#__PURE__*/jsx("div", {
        children: t('auth.info.resetpassword')
      })]
    }), !requested && /*#__PURE__*/jsxs(Fragment, {
      children: [/*#__PURE__*/jsx(Input, {
        value: email,
        autoFocus: true,
        placeholder: t('auth.input.email'),
        onChange: function onChange(e) {
          return setEmail(e.target.value);
        },
        onKeyPress: function onKeyPress(e) {
          return e.key == 'Enter' ? resetPassword() : false;
        },
        resetInput: toLogin
      }), /*#__PURE__*/jsx(AuthButton, {
        disabled: email.length == 0,
        onClick: resetPassword,
        children: t('auth.button.resetpassword')
      })]
    }), requested && /*#__PURE__*/jsx(AuthButton, {
      disabled: sending,
      onClick: toLogin,
      children: t('auth.button.login')
    })]
  });
}

function Errormessage (_ref) {
  var hasError = _ref.hasError,
    authErrorsg = _ref.authErrorsg;
  var _useTranslation = useTranslation(),
    t = _useTranslation.t;
  return /*#__PURE__*/jsxs("div", {
    className: error,
    children: [/*#__PURE__*/jsx("span", {}), hasError == 'INVALID' && /*#__PURE__*/jsx("div", {
      children: t('auth.error.verifypassword')
    }), hasError == 'SERVER' && /*#__PURE__*/jsx("div", {
      children: authErrorsg
    })]
  });
}

var LOG$1 = getLogger('Framework', 'cfhange-password');
function ChangePassword (_ref) {
  var _configurationStore$a;
  var token = _ref.token;
  var _useDivaCoreContext = useDivaCoreContext(),
    configurationStore = _useDivaCoreContext.configurationStore,
    authorizationStore = _useDivaCoreContext.authorizationStore,
    apiHandler = _useDivaCoreContext.apiHandler;
    _useDivaCoreContext.loadingAndErrorStore;
  var _useState = useState(''),
    _useState2 = _slicedToArray(_useState, 2),
    password1 = _useState2[0],
    setPassword1 = _useState2[1];
  var _useState3 = useState(''),
    _useState4 = _slicedToArray(_useState3, 2),
    password2 = _useState4[0],
    setPassword2 = _useState4[1];
  var _useState5 = useState(false),
    _useState6 = _slicedToArray(_useState5, 2),
    requested = _useState6[0],
    setRequested = _useState6[1];
  var _useState7 = useState(),
    _useState8 = _slicedToArray(_useState7, 2),
    hasError = _useState8[0],
    setError = _useState8[1];
  var _useState9 = useState(''),
    _useState10 = _slicedToArray(_useState9, 2),
    authErrorsg = _useState10[0],
    setAuthErrorMsg = _useState10[1];
  var refPw2 = useRef(null);
  var _useTranslation = useTranslation(),
    t = _useTranslation.t;
  useEffect(function () {
    if (password1 === password2) {
      setError(undefined);
    }
  }, [password1, password2]);
  var resetPassword = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            setAuthErrorMsg(t('auth.error.verifypasswordserver'));
            if (!(password1.length < 8 || password1 !== password2)) {
              _context.next = 4;
              break;
            }
            setError('INVALID');
            return _context.abrupt("return");
          case 4:
            _context.prev = 4;
            _context.next = 7;
            return apiHandler.resetPassword({
              password: password1,
              token: token
            });
          case 7:
            setRequested(true);
            _context.next = 13;
            break;
          case 10:
            _context.prev = 10;
            _context.t0 = _context["catch"](4);
            handleError(_context.t0);
          case 13:
          case "end":
            return _context.stop();
        }
      }, _callee, null, [[4, 10]]);
    }));
    return function resetPassword() {
      return _ref2.apply(this, arguments);
    };
  }();
  var handleError = function handleError(e) {
    if (e instanceof DivaError) {
      switch (e.name) {
        case 'AUTH_0003':
          setAuthErrorMsg(t('auth.error.verifypasswordtokenerror', {
            errormsg: t('auth.error.tokenexpired')
          }));
          break;
        default:
          setAuthErrorMsg(t('auth.error.verifypasswordserver', e.message));
      }
      LOG$1.error(e);
    }
    LOG$1.error(new DivaError('Error while resetting password', {
      cause: e
    }));
    setError('SERVER');
  };
  var goToLogin = function goToLogin() {
    authorizationStore.close();
    authorizationStore.showLogin();
  };
  var onClickRequestNewPassword = function onClickRequestNewPassword() {
    authorizationStore.showRequestNewPassword('');
  };
  if (hasError === 'SERVER') {
    return /*#__PURE__*/jsxs(Fragment, {
      children: [/*#__PURE__*/jsx(Errormessage, {
        hasError: hasError,
        authErrorsg: authErrorsg
      }), /*#__PURE__*/jsx(AuthButton, {
        onClick: onClickRequestNewPassword,
        children: t('auth.button.resetpassword')
      })]
    });
  }
  return /*#__PURE__*/jsxs(Fragment, {
    children: [/*#__PURE__*/jsx("h1", {
      children: t('auth.title.verifypassword')
    }), requested && /*#__PURE__*/jsxs(Fragment, {
      children: [/*#__PURE__*/jsxs("div", {
        className: success,
        children: [/*#__PURE__*/jsx("span", {}), /*#__PURE__*/jsx("div", {
          children: t('auth.info.verifypassword')
        })]
      }), ((_configurationStore$a = configurationStore.authentication.resetPassword) === null || _configurationStore$a === void 0 ? void 0 : _configurationStore$a.returnToLogin) && /*#__PURE__*/jsx(AuthButton, {
        onClick: goToLogin,
        children: t('auth.button.login')
      })]
    }), !requested && /*#__PURE__*/jsxs(Fragment, {
      children: [hasError && /*#__PURE__*/jsx(Errormessage, {
        hasError: hasError,
        authErrorsg: authErrorsg
      }), /*#__PURE__*/jsxs("form", {
        children: [/*#__PURE__*/jsx(Input, {
          value: password1,
          autoFocus: true,
          placeholder: t('auth.input.password'),
          type: "password",
          autoComplete: "new-password",
          onChange: function onChange(e) {
            return setPassword1(e.target.value);
          },
          onKeyPress: function onKeyPress(e) {
            var _refPw2$current;
            return e.key == 'Enter' ? (_refPw2$current = refPw2.current) === null || _refPw2$current === void 0 ? void 0 : _refPw2$current.focus() : false;
          }
        }), /*#__PURE__*/jsx(Input, {
          ref: refPw2,
          value: password2,
          placeholder: t('auth.input.verifypassword'),
          type: "password",
          autoComplete: "new-password",
          onChange: function onChange(e) {
            return setPassword2(e.target.value);
          },
          onKeyPress: function onKeyPress(e) {
            return e.key == 'Enter' ? resetPassword() : false;
          }
        })]
      }), /*#__PURE__*/jsx(AuthButton, {
        disabled: !password1 || !password2,
        onClick: resetPassword,
        children: t('auth.button.save')
      })]
    })]
  });
}

var divaLogo = "data:image/svg+xml,%3Csvg%20xmlns%3D%22http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%22%20%20viewBox%3D%220%200%201000%20293.65%22%3E%3Cpath%20d%3D%22M250.89%2C147.3c-3.18-74-30.4-143.18-141.73-143.18L0%2C4.26A307.86%2C307.86%2C0%2C0%2C1%2C26.12%2C60.7h74.2c52.86%2C0%2C76%2C25.68%2C78.61%2C85.29%2C2.66%2C61.81-18.29%2C87.92-71.15%2C87.92H79.2l-46.71.52a287.29%2C287.29%2C0%2C0%2C1-20%2C53.88h109c111.32%2C0%2C132.67-67%2C129.48-141M306.84%2C289h71.23V0a300.07%2C300.07%2C0%2C0%2C1-71.23%2C25.92Zm318.8.62L726.59.85a300%2C300%2C0%2C0%2C1-83.65%2C32.24L577.11%2C224%2C511.29%2C33.09A300%2C300%2C0%2C0%2C1%2C427.64.85l101%2C288.76Zm374.36%2C4L899.05%2C4.91H802L775.14%2C81.74%2C701.05%2C293.65A300.32%2C300.32%2C0%2C0%2C1%2C785%2C261.35l6.79-21%2C19.14-57.54L850.52%2C62l40.07%2C120.85%2C18.7%2C57.54%2C7%2C21A300.2%2C300.2%2C0%2C0%2C1%2C1000%2C293.65%22%20fill%3D%22%23b3b3b3%22%2F%3E%3C%2Fsvg%3E";

function WelcomeScreen (_ref) {
  var isNewUser = _ref.isNewUser,
    invitationId = _ref.invitationId,
    invitationOrgId = _ref.invitationOrgId;
  var _useDivaCoreContext = useDivaCoreContext(),
    authorizationStore = _useDivaCoreContext.authorizationStore,
    authorizationHandler = _useDivaCoreContext.authorizationHandler;
  var _useState = useState(''),
    _useState2 = _slicedToArray(_useState, 2),
    invitationError = _useState2[0],
    setInvitationError = _useState2[1];
  var _useTranslation = useTranslation(),
    t = _useTranslation.t;
  var toLogin = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var invitationMail;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return checkInvitation();
          case 2:
            invitationMail = _context.sent;
            if (invitationMail) {
              authorizationStore.close();
              authorizationStore.showLogin(undefined, undefined, invitationOrgId, invitationId, invitationMail);
            }
          case 4:
          case "end":
            return _context.stop();
        }
      }, _callee);
    }));
    return function toLogin() {
      return _ref2.apply(this, arguments);
    };
  }();
  var toRegister = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
      var invitationMail;
      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return checkInvitation();
          case 2:
            invitationMail = _context2.sent;
            if (invitationMail) {
              authorizationStore.close();
              authorizationStore.showRegister(invitationId, invitationMail);
            }
          case 4:
          case "end":
            return _context2.stop();
        }
      }, _callee2);
    }));
    return function toRegister() {
      return _ref3.apply(this, arguments);
    };
  }();
  function checkInvitation() {
    return _checkInvitation.apply(this, arguments);
  }
  function _checkInvitation() {
    _checkInvitation = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
      var _authorizationStore$s;
      var invitationId, invitation;
      return _regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) switch (_context3.prev = _context3.next) {
          case 0:
            invitationId = (_authorizationStore$s = authorizationStore.state) === null || _authorizationStore$s === void 0 ? void 0 : _authorizationStore$s.invitationId;
            _context3.next = 3;
            return authorizationHandler.getInvitationValue('email', invitationId);
          case 3:
            invitation = _context3.sent;
            if (!invitation) {
              _context3.next = 8;
              break;
            }
            return _context3.abrupt("return", invitation.email);
          case 8:
            setInvitationError('Invitation not found');
            return _context3.abrupt("return", undefined);
          case 10:
          case "end":
            return _context3.stop();
        }
      }, _callee3);
    }));
    return _checkInvitation.apply(this, arguments);
  }
  return /*#__PURE__*/jsxs(Fragment, {
    children: [/*#__PURE__*/jsx(Header, {
      title: t('auth.title.welcome'),
      text: t('auth.info.welcomedescription', ''),
      errorText: invitationError !== null && invitationError !== void 0 ? invitationError : ''
    }), isNewUser && !invitationError && /*#__PURE__*/jsx(AuthButton, {
      onClick: toRegister,
      children: t('auth.title.register')
    }), !isNewUser && !invitationError && /*#__PURE__*/jsx(AuthButton, {
      onClick: toLogin,
      children: t('auth.button.login')
    })]
  });
}

var LOG = getLogger('Framework', 'Register');
function Register() {
  var _email, _authorizationStore$s, _authorizationStore$s3, _authorizationStore$s4, _configurationStore$n, _configurationStore$n2;
  var _useDivaCoreContext = useDivaCoreContext(),
    authorizationStore = _useDivaCoreContext.authorizationStore,
    configurationStore = _useDivaCoreContext.configurationStore;
  var _useTranslation = useTranslation(),
    t = _useTranslation.t;
  var _useState = useState((_email = (_authorizationStore$s = authorizationStore.state) === null || _authorizationStore$s === void 0 ? void 0 : _authorizationStore$s.email) !== null && _email !== void 0 ? _email : ''),
    _useState2 = _slicedToArray(_useState, 2),
    email = _useState2[0],
    setEmail = _useState2[1];
  var _useState3 = useState(''),
    _useState4 = _slicedToArray(_useState3, 2),
    password = _useState4[0],
    setPassword = _useState4[1];
  var _useState5 = useState(''),
    _useState6 = _slicedToArray(_useState5, 2),
    repeatPassword = _useState6[0],
    setRepeatPassword = _useState6[1];
  var _useState7 = useState(''),
    _useState8 = _slicedToArray(_useState7, 2),
    familyname = _useState8[0],
    setFamilyname = _useState8[1];
  var _useState9 = useState(''),
    _useState10 = _slicedToArray(_useState9, 2),
    firstname = _useState10[0],
    setFirstname = _useState10[1];
  var _useState11 = useState(''),
    _useState12 = _slicedToArray(_useState11, 2),
    errorText = _useState12[0],
    setErrorText = _useState12[1];
  var _useState13 = useState(''),
    _useState14 = _slicedToArray(_useState13, 2),
    otp = _useState14[0],
    setOtp = _useState14[1];
  var _useState15 = useState(false),
    _useState16 = _slicedToArray(_useState15, 2),
    loading = _useState16[0],
    setLoading = _useState16[1];
  var _useState17 = useState(false),
    _useState18 = _slicedToArray(_useState17, 2),
    agbAccepted = _useState18[0],
    setAgbAccepted = _useState18[1];
  var onRegister = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var _authorizationStore$s2;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            setLoading(true);
            _context.next = 4;
            return flowResult(authorizationStore.register(email, password, firstname, familyname, (_authorizationStore$s2 = authorizationStore.state) === null || _authorizationStore$s2 === void 0 ? void 0 : _authorizationStore$s2.invitationId, useOtp ? otp : undefined));
          case 4:
            setEmail('');
            setPassword('');
            setRepeatPassword('');
            setFirstname('');
            setFamilyname('');
            _context.next = 15;
            break;
          case 11:
            _context.prev = 11;
            _context.t0 = _context["catch"](0);
            setErrorText('auth.error.invitationotp');
            LOG.error(new DivaError('Error while registering', {
              cause: _context.t0
            }));
          case 15:
            _context.prev = 15;
            setLoading(false);
            return _context.finish(15);
          case 18:
          case "end":
            return _context.stop();
        }
      }, _callee, null, [[0, 11, 15, 18]]);
    }));
    return function onRegister() {
      return _ref.apply(this, arguments);
    };
  }();
  var useOtp = (_authorizationStore$s3 = authorizationStore.state) === null || _authorizationStore$s3 === void 0 ? void 0 : _authorizationStore$s3.useOtp;
  var validPassword = function validPassword() {
    if (useOtp) return otp != undefined && otp !== '' && password == repeatPassword && password != '' && password != undefined && agbAccepted;
    return password == repeatPassword && password != '' && password != undefined && agbAccepted;
  };
  var loginMethods = (_authorizationStore$s4 = authorizationStore.state) === null || _authorizationStore$s4 === void 0 ? void 0 : _authorizationStore$s4.loginMethods;
  return /*#__PURE__*/jsxs(Fragment, {
    children: [/*#__PURE__*/jsx(Header, {
      title: t('auth.title.register'),
      text: t('auth.text.register', ''),
      errorText: errorText !== null && errorText !== void 0 ? errorText : ''
    }), /*#__PURE__*/jsx(OpenId, {}), ((loginMethods === null || loginMethods === void 0 ? void 0 : loginMethods.generic) || (loginMethods === null || loginMethods === void 0 ? void 0 : loginMethods.google) || (loginMethods === null || loginMethods === void 0 ? void 0 : loginMethods.microsoft)) && loginMethods.standard && /*#__PURE__*/jsx("div", {
      className: separator,
      children: "or"
    }), (loginMethods === null || loginMethods === void 0 ? void 0 : loginMethods.standard) && /*#__PURE__*/jsxs(Fragment, {
      children: [/*#__PURE__*/jsxs("form", {
        children: [useOtp && /*#__PURE__*/jsx(Input, {
          type: "text",
          value: otp,
          placeholder: t('auth.input.otp'),
          onChange: function onChange(e) {
            return setOtp(e.target.value);
          }
        }), /*#__PURE__*/jsx(Input, {
          value: firstname,
          autoFocus: true,
          placeholder: t('backoffice.form.userdetails.items.name'),
          onChange: function onChange(e) {
            return setFirstname(e.target.value);
          }
        }), /*#__PURE__*/jsx(Input, {
          value: familyname,
          autoFocus: true,
          placeholder: t('backoffice.form.userdetails.items.familyName'),
          onChange: function onChange(e) {
            return setFamilyname(e.target.value);
          }
        }), /*#__PURE__*/jsx(Input, {
          value: email,
          autoComplete: "email",
          autoFocus: true,
          placeholder: t('auth.input.email'),
          disabled: true
        }), /*#__PURE__*/jsx(Input, {
          value: password,
          type: "password",
          autoFocus: true,
          placeholder: t('auth.input.newpassword'),
          onChange: function onChange(e) {
            return setPassword(e.target.value);
          }
        }), /*#__PURE__*/jsx(Input, {
          value: repeatPassword,
          type: "password",
          autoFocus: true,
          placeholder: t('auth.input.repeatpassword'),
          onChange: function onChange(e) {
            return setRepeatPassword(e.target.value);
          }
        }), /*#__PURE__*/jsxs("div", {
          style: {
            display: 'flex',
            gap: 5,
            alignItems: 'center'
          },
          children: [/*#__PURE__*/jsx(Checkbox, {
            name: "checkAGB",
            checked: agbAccepted,
            onClick: function onClick() {
              return setAgbAccepted(!agbAccepted);
            }
          }), /*#__PURE__*/jsxs("div", {
            style: {
              display: 'flex',
              flexDirection: 'column',
              fontSize: 9
            },
            children: [/*#__PURE__*/jsx("span", {
              children: t('auth.acceptprivacyandagb')
            }), /*#__PURE__*/jsxs("span", {
              children: [/*#__PURE__*/jsx("a", {
                target: "_blank",
                href: (_configurationStore$n = configurationStore.navigation.tosUrl) !== null && _configurationStore$n !== void 0 ? _configurationStore$n : 'https://www.diva-portal.de/agb',
                children: t('auth.GeneralTerms')
              }), ",\xA0", /*#__PURE__*/jsx("a", {
                target: "_blank",
                href: (_configurationStore$n2 = configurationStore.navigation.privacyUrl) !== null && _configurationStore$n2 !== void 0 ? _configurationStore$n2 : 'https://www.diva-portal.de/datenschutz',
                children: t('auth.privacypolicy')
              })]
            })]
          })]
        }), /*#__PURE__*/jsx(Alert$1, {
          severity: "warning",
          sx: {
            display: validPassword() ? 'none' : 'flex'
          },
          children: t('auth.input.passwordsnotmatch')
        })]
      }), /*#__PURE__*/jsxs(AuthButton, {
        disabled: !validPassword() || loading,
        onClick: validPassword() ? onRegister : undefined,
        children: [loading ? /*#__PURE__*/jsx(CircularProgress$1, {
          size: 24,
          color: "inherit"
        }) : undefined, loading ? undefined : t('auth.input.login')]
      })]
    })]
  });
}
var Register$1 = observer(Register);

function Auth() {
  var _configurationStore$n3, _dataStore$organizati3, _configurationStore$n4, _configurationStore$c;
  var _useDivaCoreContext = useDivaCoreContext(),
    authorizationStore = _useDivaCoreContext.authorizationStore,
    configurationStore = _useDivaCoreContext.configurationStore,
    dataStore = _useDivaCoreContext.dataStore,
    contentStore = _useDivaCoreContext.contentStore;
  var logo = useMemo(function () {
    var _dataStore$organizati, _configurationStore$n;
    var logo = divaLogo;
    if ((_dataStore$organizati = dataStore.organization) !== null && _dataStore$organizati !== void 0 && _dataStore$organizati.logoUrl) {
      var _dataStore$organizati2;
      logo = (_dataStore$organizati2 = dataStore.organization) === null || _dataStore$organizati2 === void 0 ? void 0 : _dataStore$organizati2.logoUrl;
    } else if ((_configurationStore$n = configurationStore.navigation) !== null && _configurationStore$n !== void 0 && _configurationStore$n.logoUrl) {
      var _configurationStore$n2;
      logo = (_configurationStore$n2 = configurationStore.navigation) === null || _configurationStore$n2 === void 0 ? void 0 : _configurationStore$n2.logoUrl;
    }
    return logo;
  }, [(_configurationStore$n3 = configurationStore.navigation) === null || _configurationStore$n3 === void 0 ? void 0 : _configurationStore$n3.logoUrl, (_dataStore$organizati3 = dataStore.organization) === null || _dataStore$organizati3 === void 0 ? void 0 : _dataStore$organizati3.logoUrl]);
  if (authorizationStore.state == undefined) {
    return /*#__PURE__*/jsx(Fragment, {});
  }
  return /*#__PURE__*/jsxs("div", {
    className: auth,
    children: [(configurationStore === null || configurationStore === void 0 || (_configurationStore$n4 = configurationStore.navigation) === null || _configurationStore$n4 === void 0 ? void 0 : _configurationStore$n4.showSnow) && /*#__PURE__*/jsx(Snowfall, {
      color: "#a7b6eb",
      speed: [0, 2.5],
      wind: [-1, 0.5],
      snowflakeCount: 300,
      radius: [0.5, 2],
      style: {
        zIndex: 1000
      }
    }), /*#__PURE__*/jsxs("div", {
      className: loginBox,
      children: [(!contentStore.containerDimensions.isMobile || contentStore.containerDimensions.isPortrait) && /*#__PURE__*/jsx("div", {
        className: logoContainer,
        style: {
          height: (_configurationStore$c = configurationStore.configuration.loginLogoHeight) !== null && _configurationStore$c !== void 0 ? _configurationStore$c : 50,
          backgroundImage: "url(".concat(logo, ")")
        }
      }), /*#__PURE__*/jsx(AuthElements, {})]
    }), configurationStore.authentication.contentBox && !contentStore.containerDimensions.isMobile && /*#__PURE__*/jsx("div", {
      style: {
        width: 'calc(100% - 400px)',
        height: '100%',
        position: 'relative',
        overflow: 'hidden'
      },
      children: /*#__PURE__*/jsx(ContentBoxComponent, {
        settings: {
          contentBoxProps: toJS(configurationStore.authentication.contentBox.props)
        }
      })
    })]
  });
}
var AuthElements = observer(function () {
  var _authorizationStore$s;
  var _useDivaCoreContext2 = useDivaCoreContext(),
    authorizationStore = _useDivaCoreContext2.authorizationStore;
  switch ((_authorizationStore$s = authorizationStore.state) === null || _authorizationStore$s === void 0 ? void 0 : _authorizationStore$s.type) {
    case 'LOGIN':
      return /*#__PURE__*/jsx(Login$1, {});
    case 'REQUEST_NEW_PASSWORD':
      return /*#__PURE__*/jsx(RequestNewPassword, {
        initEmail: authorizationStore.state.email
      });
    case 'CHANGE_PASSWORD':
      return /*#__PURE__*/jsx(ChangePassword, {
        token: authorizationStore.state.token
      });
    case 'WELCOME':
      return /*#__PURE__*/jsx(WelcomeScreen, {
        isNewUser: authorizationStore.state.isNewUser,
        invitationId: authorizationStore.state.invitationId,
        invitationOrgId: authorizationStore.state.invitationOrgId
      });
    case 'REGISTER':
      return /*#__PURE__*/jsx(Register$1, {});
    case 'INVITATION_EXPIRED':
      return /*#__PURE__*/jsx("h1", {
        children: "Abgelaufen"
      });
    default:
      return /*#__PURE__*/jsx(Fragment, {});
  }
});
var index = observer(Auth);

export { index as default };
