import { IRootStore } from '../../store/RootStore';
import { AnyHistoryProps, BaseProps, CatalogHistroyEndPoint, LeadParams, OptionEndPoint } from './types';
export * from './types';
export declare const ONE_DAY_UNIX = 86400000;
export declare class AnalyticsHandler {
    private root;
    constructor(root: IRootStore);
    private get analyticsService();
    private get jwt();
    getAnalyticsData({ path, ...props }: BaseProps | AnyHistoryProps): Promise<any>;
    processHistroyData(data: {
        count: number;
        time: {
            timeStamp: number;
            count: number;
        }[];
    }[], endPoint: CatalogHistroyEndPoint, keyMapping: {
        [key: string]: string;
    } | undefined, interval: number, fromTimeStamp: number, toTimeStamp: number): {
        valueLabels: string[];
        data: number[];
        label: string;
        key?: string;
    }[];
    processData(data: {
        count: number;
        valueKey: {
            codex: string;
            count: number;
        }[];
    }[], endPoint: OptionEndPoint, keyMapping?: {
        [key: string]: string;
    }): {
        valueLabels: string[];
        data: number[];
        label: string;
        key?: string;
    }[];
    private mapKeys;
    private addBaseParamsToUrl;
    getCatalogHistorypath(): string;
    getSupplierHistorypath(): string;
    getProductsHistorypath(): string;
    getUserHistorypath(): string;
    getSupplierOptionCodexPath(): string;
    createLead(data: LeadParams): Promise<any>;
}
//# sourceMappingURL=index.d.ts.map