export interface BaseProps {
    fromTimeStamp: number;
    toTimeStamp: number;
    organizationId?: string;
    supplierGuid?: string;
    optionCodex?: string;
    catalogCodex?: string;
    size?: number;
    path: string;
}
export interface HistoryBaseProps extends BaseProps {
    interval?: string;
    timeZone?: string;
}
export type AnyHistoryProps = UsersHistoryProps | SupplierHistoryProps | CatalogHistoryProps | ProductsHistoryProps;
export interface UsersHistoryProps extends HistoryBaseProps {
    userIds?: string[];
    organizationId: string;
}
export interface SupplierHistoryProps extends HistoryBaseProps {
    supplierGuids: string;
}
export interface CatalogHistoryProps extends HistoryBaseProps {
    catalogCodexes: string;
    supplierGuids: string;
}
export interface ProductsHistoryProps extends HistoryBaseProps {
    catalogCodexes?: string;
    supplierGuids?: string;
    productIds?: string;
}
export type EndpointsProps = OptionEndPoint | CatalogHistroyEndPoint;
interface EndPointBaseProps {
    seletcionFilterKey: string;
    valueKey: string;
    key: string;
    path: string;
}
export interface OptionEndPoint extends EndPointBaseProps {
    type: 'options';
    endPointType: 'basic';
    filters: {
        supplierGuid: string;
        catalogCodex?: string;
        optionCodex: string;
    };
}
export interface CatalogHistroyEndPoint extends EndPointBaseProps {
    type: 'catalog';
    endPointType: 'history';
    filters: {
        supplierGuid: string;
        catalogCodex: string;
    };
}
export interface LeadParams {
    organizationId: string;
    divaNr: string;
    email?: string;
    firstName?: string;
    lastName?: string;
    phone?: string;
    message?: string;
    pdfUrl?: string;
    divaWebPlannerUrl?: string;
    marketingAccepted: boolean;
    type?: 'SAVED_PLANNING' | 'CREATE_APPOINTMENT';
}
export {};
//# sourceMappingURL=types.d.ts.map