import { OrganizationType, OrganizationData, EmailContent } from '../types';
import { IRootStore } from '../store/RootStore';
export default class ApiHandler {
    private root;
    constructor(root: IRootStore);
    private get adminService();
    private get messageService();
    private get authService();
    private get catalogService();
    private get jwt();
    private get organizationId();
    fetchConfiguration({ identifier, domain, organizationId, type, }: {
        identifier?: string;
        domain?: string;
        organizationId?: string;
        type: string;
    }): Promise<any>;
    sendEmail({ content, organizationIds }: {
        content: EmailContent;
        organizationIds?: string[];
    }): Promise<any>;
    sendPasswordRecoveryMail({ email }: {
        email: string;
    }): Promise<void>;
    resetPassword(data: {
        password: string;
        token: string;
    }): Promise<void>;
    sendVerificationEmail({ email, emailVariant }: {
        email: string;
        emailVariant: string;
    }): Promise<void>;
    verifyEmail(data: {
        token: string;
    }): Promise<string>;
    fetchOrganization(organizationId: string): Promise<OrganizationData | undefined | 'FORBIDDEN'>;
    fetchProduct({ divaNr }: {
        divaNr: string;
    }): Promise<{
        organizationId: string;
        productId: string;
        modelName: string;
    } | undefined>;
    getRootOrganization(userId: string): Promise<any>;
    getOrganizationsChildren(userId: string, allowedOrganizationTypes: OrganizationType[], organizationId?: string, skip?: number, allowed?: string[], excluded?: string[], limit?: number, filterText?: string): Promise<{
        data: {
            _id: string;
            displayName: string;
            type?: string;
            hasChildren: true;
            parentOrganizations?: {
                _id: string;
                displayName: string;
                type?: string;
            }[];
        }[];
        total: number;
        flatTotal: number;
    }>;
    getOrganizationRelatives(userId: string, allowedOrganizationTypes: OrganizationType[], organizationId?: string, skip?: number, allowed?: string[], excluded?: string[], limit?: number): Promise<{
        parentOrganizations?: {
            _id: string;
            displayName: string;
        }[];
        brotherOrganizations: {
            data: {
                _id: string;
                displayName: string;
            }[];
            total: number;
        };
        childrenOrganizations: {
            data: {
                _id: string;
                displayName: string;
            }[];
            total: number;
        };
    }>;
    getOrganizationBySearch(userId: string, allowedOrganizationTypes: OrganizationType[], allowed?: string[], excluded?: string[], query?: string, skip?: number): Promise<any>;
    getOrganizationParentByType(organizationId: string, type: 'SUPPLIER' | 'RETAILER'): Promise<any>;
    getRetailerLocationsForArea(organizationId: string, location: google.maps.LatLng | undefined, radius: string): Promise<any>;
    private fetch;
}
//# sourceMappingURL=InternalApiHandler.d.ts.map