import { IRootStore } from '../../store/RootStore';
export declare class OrganizationHandler {
    private root;
    constructor(root: IRootStore);
    private get apiHandler();
    private get organization();
    private get user();
    private get allowedOrganizationTypes();
    private get validOrganizations();
    private get excludedOrganizations();
    getOrganizationsChildren(organizationId?: string, skip?: number, limit?: number, filterText?: string): Promise<{
        data: {
            _id: string;
            displayName: string;
            type?: string;
            hasChildren: true;
            parentOrganizations?: {
                _id: string;
                displayName: string;
                type?: string;
            }[];
        }[];
        total: number;
        flatTotal: number;
    }>;
    getOrganizationRelatives(organizationId?: string, skip?: number, limit?: number): Promise<{
        parentOrganizations: {
            _id: string;
            displayName: string;
        }[] | undefined;
        brotherOrganizations: {
            data: {
                _id: string;
                displayName: string;
            }[];
            total: number;
        };
        childrenOrganizations: {
            data: {
                _id: string;
                displayName: string;
            }[];
            total: number;
        };
        data?: undefined;
        total?: undefined;
    } | {
        data: never[];
        total: number;
        parentOrganizations?: undefined;
        brotherOrganizations?: undefined;
        childrenOrganizations?: undefined;
    }>;
    getOrganizationBySearch(query?: string, skip?: number): Promise<any>;
    getOrganizationDataById(organizationId: string): Promise<import("../..").OrganizationData | "FORBIDDEN" | undefined>;
    getOrganizationParentByType(organizationId: string, type: 'SUPPLIER' | 'RETAILER'): Promise<any>;
    getRetailerLocationsForArea(organizationId: string, location: google.maps.LatLng | undefined, radius: string): Promise<any>;
}
//# sourceMappingURL=index.d.ts.map