import { MediaAbstract, ProductHandlerAbstract } from '@crystaldesign/product-handler';
import { IRootStore } from '../../store/RootStore';
import { Media } from './types';
import { Modal } from '../../types';
export * from './types';
export declare class ProductHandler extends ProductHandlerAbstract {
    private root;
    constructor(root: IRootStore, openModal?: (modal: Modal) => void, closeModal?: () => void);
    get catalogService(): string;
    get mediaService(): string;
    get basketService(): string;
    get api2(): string;
    get sessionGuid(): Promise<any>;
    get organization(): import("../../externalTypes").OrganizationData | undefined;
    get user(): import("../../externalTypes").UserData | undefined;
    get langs(): string[];
    get jwt(): string | undefined;
    saveProductMedia(productmedia: Media, organizationId: string, refCount?: number, refIds?: string[]): Promise<(MediaAbstract & {
        refs?: string[];
    }) | undefined>;
    saveMedias(mediasToSave: {
        media: Media;
        id: string;
    }[], organizationId: string): Promise<{
        [id: string]: {
            medias: MediaAbstract[];
        };
    }>;
}
//# sourceMappingURL=index.d.ts.map