import { IRootStore } from '../../store/RootStore';
import { ActivePlanning, ClientRequest, RequestStatus } from './types';
export * from './types';
export declare class SupportHandler {
    private root;
    constructor(root: IRootStore);
    private get supportService();
    private get jwt();
    getCometChatApiToken(): Promise<any>;
    createCometChatGroup(divaNr: string, participantEmail?: string | undefined): Promise<any>;
    joinCometChatGroup(guid: string): Promise<any>;
    listCometChatConversations(): Promise<Record<string, any>[]>;
    sendCometChatMessage(guid: string, message: string): Promise<any>;
    sendCometChatImage(guid: string, imageUrl: string): Promise<any>;
    listFriends(): Promise<Record<string, any>[]>;
    createClientRequest(clientRequest: {
        name: string;
        description: number;
        divaNr: string;
        zipCode: string;
        retailerId: string;
        consultantId?: string;
    }): Promise<ClientRequest>;
    updateClientRequest(id: string, state: RequestStatus): Promise<ClientRequest>;
    listClientRequests(): Promise<{
        data: ClientRequest[];
    }>;
    listActivePlannings(): Promise<ActivePlanning[]>;
}
//# sourceMappingURL=index.d.ts.map