import { DivaError } from '@crystaldesign/diva-utils';
import RootStore from './RootStore';
export default class {
    private root;
    private loading;
    private spinnerClass?;
    private cssFile?;
    private _errorMsg?;
    private span?;
    private _divaErrorCode?;
    private _fallbackModule?;
    private _userFriendlyErrorMsg?;
    private _validOrgId?;
    private _showLogout?;
    private _detailErrorMsg?;
    constructor(root: RootStore, spinnerClass?: string);
    private setCustomLoader;
    get showLogout(): boolean | undefined;
    get errorMsg(): string | undefined;
    get detailErrorMsg(): string | undefined;
    get divaErrorCode(): string | undefined;
    get fallbackModule(): {
        route: any;
        organizationId?: string;
        text?: string;
    } | undefined;
    get userFriendlyErrorMsg(): any;
    get validOrgId(): string | undefined;
    get customLoader(): {
        spinnerClass: string | undefined;
        cssFile: string | undefined;
    };
    get isLoading(): boolean;
    get error(): string | undefined;
    setError(error?: string | DivaError, code?: string, showLogout?: boolean): void;
    get hideContent(): string | true | undefined;
    toggleLoading(id: string, hidden?: boolean, toggle?: boolean): void;
}
//# sourceMappingURL=LoadingAndErrorStore.d.ts.map